#!/bin/sh
PREFIX=$1
nm $PREFIX/libc.so > symbols.exported
exec 0<locale.symbols
MISSING=0
FOUND=0
PRIVATE=0
while read -r sym 
do
	#echo checking $sym
	if (grep " $sym" symbols.exported > /dev/null) ; then
		type=`grep " $sym" symbols.exported | awk '{print $2}'`
		# If the type is U then there are two columns
		if [ $type = $sym ] ; then
			type=`grep " $sym" symbols.exported | awk '{print $1}'`
		fi
		if [ "$type" != "T" ] ; then
			echo $sym is not the correct type of symbol: $type
			PRIVATE=`expr $PRIVATE + 1`
		else
			#echo $sym found!
			FOUND=`expr $FOUND + 1`
		fi
	else
		echo $sym missing
		MISSING=`expr $MISSING + 1`
	fi
done
rm symbols.exported
if [ $FOUND -gt 0 ]; then
	echo $FOUND symbols found
fi
if [ $MISSING -gt 0 ]; then
	echo $MISSING symbols missing 
	return 1
fi
if [ $PRIVATE -gt 0 ]; then
	echo $PRIVATE symbols found, but had the wrong type
	return 1
fi
